//main.c

#include <stdio.h>
#include <stdint.h>
#include <unistd.h>
#include <sys/mman.h>
//#include <semaphore.h>
#include <pthread.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "main.h"
#include "bmp.h"
#include "wsserver.h"
#include "workfunc.h"
#include "bmpfunc.h"
#include "msem.h"


char filenameBMP[32];		//имя файла шаблонного файла BMP
char SHCMDfilenameBMP[32];	//имя файла рзделяемой памяти BMP
char SHSEMfilenameBMP[32];	//имя семафора разделяемой памяти BMP
char SHCMDfilenameCNTRL[32];	//имя файла рзделяемой памяти CNTRL
char SHSEMfilenameCNTRL[32];	//имя семафора разделяемой памяти CNTRL

int main(int argc, char *argv[])
{
	int res;
	int scnt = 1;
	if(argc < 2)
	{
		printf("{--help}\n");
		return 1;
	}
	while(scnt < argc)
	{
		if(strcmp(argv[scnt], "--help") == 0)
		{
			printf(_help_);
			return 0;
		}
		else if(strcmp(argv[scnt], "--fcntrl") == 0)
		{
			scnt++;
			if(!(scnt < argc))
			{
				printf("не задано имя файла контроля параметров\n");
				return 3;
			}
			memset(&SHCMDfilenameCNTRL[0], 0, 32);
			strcpy(&SHCMDfilenameCNTRL[0], argv[scnt]);
			scnt++;
			if(!(scnt < argc))
			{
				printf("не задано имя семафора контроля параметров\n");
				return 3;
			}
			memset(&SHSEMfilenameCNTRL[0], 0, 32);
			strcpy(&SHSEMfilenameCNTRL[0], argv[scnt]);
		}
		else if(strcmp(argv[scnt], "--fbmp") == 0)
		{
			scnt++;
			if(!(scnt < argc))
			{
				printf("не задано имя файла шаблонного BMP файла\n");
				return 3;
			}
			memset(&filenameBMP[0], 0, 32);
			strcpy(&filenameBMP[0], argv[scnt]);
			scnt++;
			if(!(scnt < argc))
			{
				printf("не задано имя файла разделяемой памяти BMP\n");
				return 3;
			}
			memset(&SHCMDfilenameBMP[0], 0, 32);
			strcpy(&SHCMDfilenameBMP[0], argv[scnt]);
			scnt++;
			if(!(scnt < argc))
			{
				printf("не задано имя файла семафора BMP\n");
				return 3;
			}
			memset(&SHSEMfilenameBMP[0], 0, 32);
			strcpy(&SHSEMfilenameBMP[0], argv[scnt]);
		}
		else if(strcmp(argv[scnt], "-p") == 0)
		{
			scnt++;
			if(!(scnt < argc))
			{
				printf("Не задано значение параметроа порта прослушивания!\n");
				return 3;
			}
			wsport = atoi(argv[scnt]);
		}
		else
		{
			printf("{--help}\n");
			return  2;
		}
		scnt++;
	}
	//
	printf("res=%i\n", createSHMcntrl());
	printf("res=%i\n", createSHMbmp());
	shcmd = (SHCMD*)(addrCMD);
	res = startWSserver();
	if(res < 0)
		return 4;
	//
	while(1)
	{
		usleep(500000);
	}
	return 0;
}

int createSHMcntrl(void)
{
	//
	//память - создание
        if ( (shmCMD = shm_open(&SHCMDfilenameCNTRL[0], O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
                return 1;
	if ( ftruncate(shmCMD, sizeof(SHCMD) + 1) == -1 ) 
                return 2;
	if ( (addrCMD = mmap(0, sizeof(SHCMD)+1, PROT_WRITE|PROT_READ, MAP_SHARED, shmCMD, 0)) == (u_int8_t*)-1 )
                return 3;
	//псевдомютекс
	if ( (semCMD = shm_open(&SHSEMfilenameCNTRL[0], O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
                return 4;
	if ( ftruncate(semCMD, 1 + 1) == -1 ) 
                return 5;
	if ( (addrsemCMD = mmap(0, 1 + 1, PROT_WRITE|PROT_READ, MAP_SHARED, semCMD, 0)) == (u_int8_t*)-1 )
                return 6;
	//
	wmcreate(addrsemCMD, 0);
	wmutlock(addrsemCMD);
	memset(addrCMD, 0, sizeof(SHCMD));
	wmutunlock(addrsemCMD);
	return 0;
}

int createSHMbmp(void)
{
	//память - создание
        if ( (shmBMP = shm_open(&SHCMDfilenameBMP[0], O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
                return 1;
	if ( ftruncate(shmBMP, _BMP_DUMP_SIZE_ + 1) == -1 ) 
                return 2;
	if ( (addrBMP = mmap(0, _BMP_DUMP_SIZE_+1, PROT_WRITE|PROT_READ, MAP_SHARED, shmBMP, 0)) == (u_int8_t*)-1 )
                return 3;
	//
	if ( (semBMP = shm_open(&SHSEMfilenameBMP[0], O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
                return 4;
	if ( ftruncate(semBMP, sizeof(pthread_mutex_t) + 1) == -1 ) 
                return 5;
	if ( (addrsemBMP = mmap(0, sizeof(pthread_mutex_t) + 1, PROT_WRITE|PROT_READ, MAP_SHARED, semBMP, 0)) == (u_int8_t*)-1 )
                return 6;
	wmcreate(addrsemBMP, 0);
	wmutlock(addrsemBMP);
	//анализ шаблона BMP
	BMP_FileAnalise(&filenameBMP[0], addrBMP);
	wmutunlock(addrsemBMP);
	return 0;
}

